
; arp header
.equ	ARP_HWT	=	ETH_DAT + 0x00
.equ	ARP_PRT	=	ETH_DAT + 0x02
.equ	ARP_HWL	=	ETH_DAT + 0x04
.equ	ARP_PRL	=	ETH_DAT + 0x05
.equ	ARP_OPC	=	ETH_DAT + 0x06
.equ	ARP_SHW	=	ETH_DAT + 0x08
.equ	ARP_SPR	=	ETH_DAT + 0x0e
.equ	ARP_THW	=	ETH_DAT + 0x12
.equ	ARP_TPR	=	ETH_DAT + 0x18


; *
; *  arp_in - process ARP packet

arp_in:
	; check arp header
	sety	( nic_dat+ETH_DAT )
	setz	( arp_match * 2 )
	setx	8
	rcall	proto_match
	brne	arp_drop
	
	; check target ip
	sety	( nic_dat+ARP_TPR )
	setz	( myip * 2 )
	setx	4
	rcall	proto_match
	brne	arp_drop
	
	sety	nic_dat
	
	; set answer code
	ldi	dh,	0x02
	std	Y+ARP_OPC+1,	dh
	
	; shuffle macs	( target mac <- source mac <- my mac )
	sety	nic_dat
	setz	( mymac * 2 )
	ldi	dh,	6
arp_in_set_mac:
	ldd	r0,	Y+ARP_SHW
	std	Y+ARP_THW,	r0
	ldd	r0,	Y+ETH_SRC
	std	Y+ETH_DST,	r0
	lpm
	std	Y+ARP_SHW,	r0
	std	Y+ETH_SRC,	r0
	adiw	YL,	1
	adiw	ZL,	1
	dec	dh
	brne	arp_in_set_mac
	
	; swap ips	( target ip <- source ip <- my ip )
	sety	nic_dat
	setz	( myip * 2 )
	ldi	dh,	4
arp_in_set_ip:
	ldd	r0,	Y+ARP_SPR
	std	Y+ARP_TPR,	r0
	lpm
	std	Y+ARP_SPR,	r0
	adiw	YL,	1
	adiw	ZL,	1
	dec	dh
	brne	arp_in_set_ip

	;rjmp	arp_out	


; *
; *  arp_out - send arp packet

arp_out:	
	sety	nic_dat
	setx	42
	rjmp	nic_snd


arp_drop:
	ret


arp_match:
.db	0x00,0x01
.db	0x08,0x00
.db	0x06,0x04
.db	0x00,0x01

