
;***** Specify Device
.device ATmega32

;***** I/O Register Definitions
.equ	SREG	=	$3f
.equ	SPH	=	$3e
.equ	SPL	=	$3d
.equ	OCR0	=	$3c
.equ	GICR	=	$3b
.equ	GIFR	=	$3a
.equ	TIMSK	=	$39
.equ	TIFR	=	$38
.equ	SPMCR	=	$37
.equ	TWCR	=	$36
.equ	MCUCR	=	$35
.equ	MCUSR	=	$34
.equ	TCCR0	=	$33
.equ	TCNT0	=	$32
.equ	OSCCAL	=	$31
.equ	SFIOR	=	$30
.equ	TCCR1A	=	$2f
.equ	TCCR1B	=	$2e
.equ	TCNT1H	=	$2d
.equ	TCNT1L	=	$2c
.equ	OCR1AH	=	$2b
.equ	OCR1AL	=	$2a
.equ	OCR1BH	=	$29
.equ	OCR1BL	=	$28
.equ	ICR1H	=	$27
.equ	ICR1L	=	$26
.equ	TCCR2	=	$25
.equ	TCNT2	=	$24
.equ	OCR2	=	$23
.equ	ASSR	=	$22
.equ	WDTCR	=	$21
.equ	UBRRH	=	$20
.equ	UCSRC	=	$20
.equ	EEARH	=	$1f
.equ	EEARL	=	$1e
.equ	EEDR	=	$1d
.equ	EECR	=	$1c
.equ	PORTA	=	$1b
.equ	DDRA	=	$1a
.equ	PINA	=	$19
.equ	PORTB	=	$18
.equ	DDRB	=	$17
.equ	PINB	=	$16
.equ	PORTC	=	$15
.equ	DDRC	=	$14
.equ	PINC	=	$13
.equ	PORTD	=	$12
.equ	DDRD	=	$11
.equ	PIND	=	$10
.equ	SPDR	=	$0f
.equ	SPSR	=	$0e
.equ	SPCR	=	$0d
.equ	UDR	=	$0c
.equ	UCSRA	=	$0b
.equ	UCSRB	=	$0a
.equ	UBRRL	=	$09
.equ	ACSR	=	$08
.equ	ADMUX	=	$07
.equ	ADCSRA	=	$06
.equ	ADCH	=	$05
.equ	ADCL	=	$04
.equ	TWDR	=	$03
.equ	TWAR	=	$02
.equ	TWSR	=	$01
.equ	TWBR	=	$00


;***** Bit Definitions

;GIMSK
.equ	INT1	=7
.equ	INT0	=6
.equ	INT2	=5

;GIFR
.equ	INTF1	=7
.equ	INTF0	=6
.equ	INTF2	=5

;TIMSK
.equ	OCIE2	= 7
.equ	TOIE2	= 6
.equ	TICIE1	= 5
.equ	OCIE1A	= 4
.equ	OCIE1B	= 3
.equ	TOIE1	= 2
.equ	OCIE0	= 1
.equ	TOIE0	= 0

;MCUCR
.equ	SM2	= 7
.equ	SE	= 6
.equ	SM1	= 5
.equ	SM0	= 4
.equ	ISC11	= 3
.equ	ISC10	= 2
.equ	ISC01	= 1
.equ	ISC00	= 0

;TCCR0
.equ	FOC0	=7
.equ	WGM00	=6
.equ	COM01	=5
.equ	COM00	=4
.equ	WGM01	=3
.equ	CS02	=2
.equ	CS01	=1
.equ	CS00	=0

;TCCR1A
.equ	COM1A1	=7
.equ	COM1A0	=6
.equ	COM1B1	=5
.equ	COM1B0	=4
.equ	FOC1A	=3
.equ	FOC1B	=2
.equ	WGM11	=1
.equ	WGM10	=0

;TCCR1B
.equ	ICNC1	=7
.equ	ICES1	=6
.equ	WGM13	=4
.equ	WGM12	=3
.equ	CS12	=2
.equ	CS11	=1
.equ	CS10	=0

;TCCR2
.equ	FOC2	=7
.equ	WGM20	=6
.equ	COM21	=5
.equ	COM20	=4
.equ	WGM21	=3
.equ	CS22	=2
.equ	CS21	=1
.equ	CS20	=0

;EECR
.equ	EERIE	=3
.equ	EEMWE	=2
.equ	EEWE	=1
.equ	EERE	=0

;PORTA
.equ	PA7	=7
.equ	PA6	=6
.equ	PA5	=5
.equ	PA4	=4
.equ	PA3	=3
.equ	PA2	=2
.equ	PA1	=1
.equ	PA0	=0

;DDRA
.equ	DDA7	=7
.equ	DDA6	=6
.equ	DDA5	=5
.equ	DDA4	=4
.equ	DDA3	=3
.equ	DDA2	=2
.equ	DDA1	=1
.equ	DDA0	=0

;PINA
.equ	PINA7	=7
.equ	PINA6	=6
.equ	PINA5	=5
.equ	PINA4	=4
.equ	PINA3	=3
.equ	PINA2	=2
.equ	PINA1	=1
.equ	PINA0	=0

;PORTB
.equ	PB7	=7
.equ	PB6	=6
.equ	PB5	=5
.equ	PB4	=4
.equ	PB3	=3
.equ	PB2	=2
.equ	PB1	=1
.equ	PB0	=0

;DDRB
.equ	DDB7	=7
.equ	DDB6	=6
.equ	DDB5	=5
.equ	DDB4	=4
.equ	DDB3	=3
.equ	DDB2	=2
.equ	DDB1	=1
.equ	DDB0	=0

;PINB
.equ	PINB7	=7
.equ	PINB6	=6
.equ	PINB5	=5
.equ	PINB4	=4
.equ	PINB3	=3
.equ	PINB2	=2
.equ	PINB1	=1
.equ	PINB0	=0

;PORTC
.equ	PC7	=7
.equ	PC6	=6
.equ	PC5	=5
.equ	PC4	=4
.equ	PC3	=3
.equ	PC2	=2
.equ	PC1	=1
.equ	PC0	=0

;DDRC
.equ	DDC7	=7
.equ	DDC6	=6
.equ	DDC5	=5
.equ	DDC4	=4
.equ	DDC3	=3
.equ	DDC2	=2
.equ	DDC1	=1
.equ	DDC0	=0

;PINC
.equ	PINC7	=7
.equ	PINC6	=6
.equ	PINC5	=5
.equ	PINC4	=4
.equ	PINC3	=3
.equ	PINC2	=2
.equ	PINC1	=1
.equ	PINC0	=0

;PORTD
.equ	PD7	=7
.equ	PD6	=6
.equ	PD5	=5
.equ	PD4	=4
.equ	PD3	=3
.equ	PD2	=2
.equ	PD1	=1
.equ	PD0	=0

;DDRD
.equ	DDD7	=7
.equ	DDD6	=6
.equ	DDD5	=5
.equ	DDD4	=4
.equ	DDD3	=3
.equ	DDD2	=2
.equ	DDD1	=1
.equ	DDD0	=0

;PIND
.equ	PIND7	=7
.equ	PIND6	=6
.equ	PIND5	=5
.equ	PIND4	=4
.equ	PIND3	=3
.equ	PIND2	=2
.equ	PIND1	=1
.equ	PIND0	=0

;ADCSRA
.equ	ADEN	= 7
.equ	ADSC	= 6
.equ	ADATE	= 5
.equ	ADIF	= 4
.equ	ADIE	= 3
.equ	ADPS2	= 2
.equ	ADPS1	= 1
.equ	ADPS0	= 0

;ADMUX
.equ	REFS1	= 7
.equ	REFS0	= 6
.equ	ADLAR	= 5
.equ	MUX4	= 4
.equ	MUX3	= 3
.equ	MUX2	= 2
.equ	MUX1	= 1
.equ	MUX0	= 0

;SPCR
.equ	SPIE	= 7
.equ	SPE	= 6
.equ	DORD	= 5
.equ	MSTR	= 4
.equ	CPOL	= 3
.equ	CPHA	= 2
.equ	SPR1	= 1
.equ	SPR0	= 0

;SPSR
.equ	SPIF	= 7
.equ	WCOL	= 6
.equ	SP2X	= 0

; UCSRC
.equ	UCPOL	= 0
.equ	UCSZ0	= 1
.equ	UCSZ1	= 2
.equ	USBS	= 3
.equ	UPM0	= 4
.equ	UPM1	= 5
.equ	UMSEL	= 6
.equ	URSEL	= 7

; UCSRB
.equ	TXB8	= 0
.equ	RXB8	= 1
.equ	UCSZ2	= 2
.equ	TXEN	= 3
.equ	RXEN	= 4
.equ	UDRIE	= 5
.equ	TXCIE	= 6
.equ	RXCIE	= 7

; UCSRA
.equ	MPCM	= 0
.equ	U2X	= 1
.equ	PE	= 2
.equ	DOR	= 3
.equ	FE	= 4
.equ	UDRE	= 5
.equ	TXC	= 6
.equ	RXC	= 7

;X,Y,Z pointer
.def	XL	=r26
.def	XH	=r27
.def	YL	=r28
.def	YH	=r29
.def	ZL	=r30
.def	ZH	=r31

.equ 	FLASHEND	= $3FFF
.equ 	E2END	= $3FF
.equ	RAMEND	= $85F
.equ	XRAMEND	= $FFFF

.equ	BOOTSTART	= $3C00
.equ	PAGESIZE	= 64


.equ	INT0addr	= $002
.equ	INT1addr	= $004
.equ	INT2addr	= $006
.equ	TCP2addr	= $008
.equ	TOF2addr	= $00a
.equ	TCT1addr	= $00c
.equ	TCA1addr	= $00e
.equ	TCB1addr	= $010
.equ	TOF1addr	= $012
.equ	TCP0addr	= $014
.equ	TOF0addr	= $016
.equ	SPIaddr	= $018
.equ	URXaddr	= $01a
.equ	UDRaddr	= $01c
.equ	UTXaddr	= $01e
.equ	ADCaddr	= $020
.equ	EERaddr	= $022
.equ	ACIaddr	= $024
.equ	TWIaddr	= $026
.equ	SPMaddr	= $028
