
; icmp header

.equ	ICMP_TYP	=	IP_DAT + 0x00
.equ	ICMP_COD	=	IP_DAT + 0x01
.equ	ICMP_CHK	=	IP_DAT + 0x02
.equ	ICMP_IDD	=	IP_DAT + 0x04
.equ	ICMP_SEQ	=	IP_DAT + 0x06
.equ	ICMP_DAT	=	IP_DAT + 0x08


; *
; *  process icmp packet

icmp_in:
	; check ip address
	sety	(nic_dat+IP_DST)
	setz	(myip*2)
	setx	3
	rcall	proto_match
	brne	icmp_drop

	ld	dl,	Y+
	tst	dl
	breq	icmp_addr_match
	cpi	dl,	255
	breq	icmp_addr_match

	lpm	dh,	Z+
	cpse	dl,	dh
	rjmp	icmp_drop

icmp_addr_match:
	; check for icmp echo request
	sety	nic_dat
	ldd	dh,	Y+ICMP_TYP
	ldd	dl,	Y+ICMP_COD
	cpi	dh,	0x08
	brne	icmp_chk_dest
	tst	dl
	brne	icmp_chk_dest

	; setup ip header
	rcall	ip_header

	; set icmp echo reply code
	sety	nic_dat
	clr	dl
	std	Y+ICMP_TYP,	dl
	std	Y+ICMP_COD,	dl

	;rjmp	icmp_out


; *
; *  send icmp packet

icmp_out:
	sety	nic_dat
	; clear checksum
	clr	dl
	std	Y+ICMP_CHK,	dl
	std	Y+ICMP_CHK+1,	dl
	; calculate icmp checksum
	ldd	XH,	Y+IP_LEN
	ldd	XL,	Y+IP_LEN+1
	subi	XL,	20
	sbci	XH,	0
	sety	( nic_dat+IP_DAT )
	rcall	inet_chksum
	; store new checksum
	sety	nic_dat
	std	Y+ICMP_CHK+0,	dh
	std	Y+ICMP_CHK+1,	dl

	rjmp	ip_out


	; stop can message forwarding if remote host unavailable
icmp_chk_dest:
	cpi	dh,	0x03
	brne	icmp_drop
	cpi	dl,	0x03
	brne	icmp_drop

	sety	(nic_dat+ICMP_DAT-ETH_DAT)
	ldd	dh,	Y+IP_PRT
	cpi	dh,	IP_PRT_UDP
	brne	icmp_drop

	setz	udp_sav
	ldd	dh,	Y+UDP_DSTPRT+0
	ld	dl,	Z+
	cpse	dh,	dl
	rjmp	icmp_drop

	ldd	dh,	Y+UDP_DSTPRT+1
	ld	dl,	Z+
	cpse	dh,	dl
icmp_drop:
	ret

	rjmp	udp_sav_clr



; *
; *  return icmp destination port unreachable message

icmp_dest_port:
	rcall	icmp_dest
	sety	nic_dat
	ldi	r16,	0x03
	std	Y+ICMP_COD,	r16
	rjmp	icmp_out


; *
; *  return icmp destination protocol unreachable message

icmp_dest_proto:
	rcall	icmp_dest
	sety	nic_dat
	ldi	r16,	0x02
	std	Y+ICMP_COD,	r16
	rjmp	icmp_out


; *
; *  setup icmp dest unreachable message body

icmp_dest:
	; copy original message header + 64 bits
	sety	nic_dat+ETH_DAT
	setz	nic_dat+ICMP_DAT
	ldi	XL,	28
icmp_dest1:
	ld	r16,	Y+
	st	Z+,	r16
	dec	XL
	brne	icmp_dest1

	; set icmp protocol
	sety	nic_dat
	ldi	r16,	IP_PRT_ICMP
	st	Y+IP_PRT,	r16
	; set ip len
	setx	(ICMP_DAT-ETH_DAT+20+8)
	st	Y+IP_LEN+0,	XH
	st	Y+IP_LEN+1,	XL
	; set ttl
	ldi	dl,	64
	std	Y+IP_TTL,	dl
	; set icmp type
	ldi	r16,	0x03
	st	Y+ICMP_TYP,	r16

	rjmp	ip_header

