
; ethernet header
.equ	ETH_DST	=	0x00
.equ	ETH_SRC	=	0x06
.equ	ETH_TYP	=	0x0c
.equ	ETH_DAT	=	0x0e

.include	"arp.asm"
.include	"icmp.asm"
.include	"ip.asm"
.include	"tcp.asm"
.include	"udp.asm"
.include	"http.asm"
.include	"i2c-rd0.asm"


; *
; *  setup routine

inet_init:
	rcall	i2c_init
	rcall	udp_init
	rcall	tcp_init
	rcall	http_init
	ret


; *
; *  check received packet

inet:
	rcall	nic_rcv
	breq	inet_done
	
	; check protocol type
	sety	nic_dat
	ldd	r16,	Y+ETH_TYP
	cpi	r16,	0x08
	brne	inet_done
	ldd	r16,	Y+ETH_TYP+1
inet_chk_arp:
	cpi	r16,	0x06
	brne	inet_chk_ip
	rjmp	arp_in
inet_chk_ip:
	cpi	r16,	0x00
	brne	inet_done
	rjmp	ip_in
inet_done:
	ret


; *
; *  calculate partial checksum
; *

; beginning of optimize challenge

inet_chksum_part:
	clr	r0
	bst	XL,	0
	lsr	XH
	ror	XL
	clc
inet_chksum_part_l:
	ld	r16,	Y+
	ld	r17,	Y+
	adc	dl,	r17
	adc	dh,	r16

	dec	XL
	brne	inet_chksum_part_l
	tst	XH
	breq	inet_chksum_part2
	dec	XH
	rjmp	inet_chksum_part_l

inet_chksum_part2:
	brtc	inet_chksum_part_fin
	ld	r16,	Y+
	adc	dl,	r0
	adc	dh,	r16
inet_chksum_part_fin:
	adc	dl,	r0
	adc	dh,	r0
	ret

; end of optimize challenge


; *
; *  calculate checksum

inet_chksum:
	clr	dl
	clr	dh
	rcall	inet_chksum_part
	ser	r16
	eor	dl,	r16
	eor	dh,	r16
	ret


; *
; *  check sram Y data against flash Z

proto_match:
	lpm	dl,	Z+
	ld	dh,	Y+
	cp	dl,	dh
	brne	proto_match_mis
	dec	XL
	brne	proto_match
proto_match_mis:
	ret
	
