
; *
; *  27*4 LCD (POLLIN)
; *

; in the beginning this was used for debugging
; not connected at the moment

.equ	LCD_DAT	=	PORTC
.equ	LCD_DDR	=	DDRC
.equ	LCD_PIN	=	PINC
.equ	LCD_CTRL	=	PORTD
.equ	LCD_CTRL_DDR	=	DDRD

.equ	LCD_RS	=	PD0
.equ	LCD_RW	=	PD1
.equ	LCD_E1	=	PD2
.equ	LCD_E2	=	PD3

;.def	_lcd_	=	r4

lcd_init:
	clr	_lcd_
	dec	_lcd_
	
	; setup lcd control port
	cbi	LCD_CTRL,	LCD_RS
	cbi	LCD_CTRL,	LCD_RW
	cbi	LCD_CTRL,	LCD_E1
	cbi	LCD_CTRL,	LCD_E2
	
	sbi	LCD_CTRL_DDR,	LCD_RS
	sbi	LCD_CTRL_DDR,	LCD_RW
	sbi	LCD_CTRL_DDR,	LCD_E1
	sbi	LCD_CTRL_DDR,	LCD_E2

	ser	r16
	out	LCD_DDR,	r16
		
	ldi	r16,	0x38
	out	LCD_DAT,	r16
	rcall	lcd_enable
	rcall	lcd_enable
	rcall	lcd_enable
	
	ldi	dl,	0b00111000
	rcall	lcd_instr
	ldi	dl,	0b00111000
	rcall	lcd_instr
	ldi	dl,	0b00001100
	rcall	lcd_instr
	ldi	dl,	0b00000001
	rcall	lcd_instr
	ldi	dl,	0b00000110
	rcall	lcd_instr
	
	rcall	lcd_clear
	
	ret
	
lcd_screen:
	; load both lines from Z
	rcall	lcd_clear
	rcall	lcd_show
	rcall	lcd_line2
	rcall	lcd_show
	rcall	lcd_line3
	rcall	lcd_show
	rcall	lcd_line4
	rjmp	lcd_show


lcd_show:
	; show string at current cursor position
	lpm	dl,	Z+
	tst	dl
	breq	lcd_show_fin
	rcall	lcd_write
	rjmp	lcd_show
lcd_show_fin:
	ret


lcd_clear:
	; clear screen
	ldi	dl,	0b00000011
	mov	_lcd_,	dl
	ldi	dl,	0b00000001
	rcall	lcd_instr
	ldi	dl,	0b00000001
	mov	_lcd_,	dl
	ret


lcd_line1:
	; move cursor to upper left corner
	ldi	dl,	1
	mov	_lcd_,	dl
	ldi	dl,	0b00000010
	rjmp	lcd_instr


lcd_line2:
	; move cursor to beginning of 2nd line
	ldi	dl,	1
	mov	_lcd_,	dl
	ldi	dl,	0b11000000
	rjmp	lcd_instr
	
lcd_line3:
	ldi	dl,	2
	mov	_lcd_,	dl
	ldi	dl,	0b00000010
	rjmp	lcd_instr


lcd_line4:
	ldi	dl,	2
	mov	_lcd_,	dl
	ldi	dl,	0b11000000
	rjmp	lcd_instr
	

lcd_instr:
	; write command
	rcall	lcd_busy

	push	r16
	
	; set lcd data port to output
	ser	r16
	out	LCD_DDR,	r16

	; write byte
	out	LCD_DAT,	dl
	cbi	LCD_CTRL,	LCD_RS
	cbi	LCD_CTRL,	LCD_RW
	rcall	lcd_enable
	
	pop	r16
	ret


lcd_write:
	; write one character
	rcall	lcd_busy

	push	r16
	
	; set lcd data port to output
	ser	r16
	out	LCD_DDR,	r16
	
	; write byte
	out	LCD_DAT,	dl
	sbi	LCD_CTRL,	LCD_RS
	cbi	LCD_CTRL,	LCD_RW
	rcall	lcd_enable

	pop	r16
	ret


lcd_enable:
	sbrc	_lcd_,	0
	sbi	LCD_CTRL,	LCD_E1
	sbrc	_lcd_,	1
	sbi	LCD_CTRL,	LCD_E2
	nop
	nop
	nop
	cbi	LCD_CTRL,	LCD_E1
	cbi	LCD_CTRL,	LCD_E2
	ret


lcd_read:
	push	r16

	; set lcd data port to input
	clr	r16
	out	LCD_DDR,	r16

	sbi	LCD_CTRL,	LCD_RW
	sbrs	_lcd_,	0
	rjmp	lcd_read2
	sbi	LCD_CTRL,	LCD_E1
	rjmp	lcd_read0
lcd_read2:
	sbi	LCD_CTRL,	LCD_E2
lcd_read0:
	nop
	nop
	nop
	in	dl,	LCD_PIN
	cbi	LCD_CTRL,	LCD_E1
	cbi	LCD_CTRL,	LCD_E2

	pop	r16
	ret

lcd_busy:
	; wait while lcd is busy
	push	dl
lcd_busy_1:
	cbi	LCD_CTRL,	LCD_RS
	rcall	lcd_read
	sbrc	dl,	7
	rjmp	lcd_busy_1

	pop	dl
	ret


lcd_write_hexquad:
	; write lower four bits of dl as hex
	push	r16
	ldi	r16,	'0'
	andi	dl,	0xf
	cpi	dl,	0xa
	brlo	lcd_write_hexquad_1
	ldi	r16,	( 'A' - 0xa )
lcd_write_hexquad_1:
	add	dl,	r16
	pop	r16
	rjmp	lcd_write


lcd_write_hex:
	; output dl in hexadecimal form
	push	dl
	swap	dl
	rcall	lcd_write_hexquad
	pop	dl
	rjmp	lcd_write_hexquad


;lcd_write_8bit:
;	push	r16
;	ldi	r16,	8
;	mov	r0,	dl
;lcd_write_8bit_loop:
;	ldi	dl,	'0'
;	rol	r0
;	brcc	lcd_write_8bit_1
;	ldi	dl,	'1'
;lcd_write_8bit_1:
;	rcall	lcd_write
;	dec	r16
;	brne	lcd_write_8bit_loop
;	pop	r16
;	ret

