#include "byteview.h"

#include <qfont.h>
#include <qpainter.h>

byteview::byteview( QWidget * parent )
	: QScrollView( parent )
{
	setFont( QFont( "courier" ) );
	
	QFontMetrics fm( font() );
	
	resizeContents( ( 3 * 16 + 6 ) * fm.width( "0" ), fm.height() * ( 65536 * 2 / 16 ) );
	
	clear();
}

void byteview::clear()
{
	for ( int i = 0; i < 65536 * 2; i++ )
		buffer[ i ] = 0xff;
}

void byteview::drawContents( QPainter * p, int cx, int cy, int cw, int ch )
{
	QFontMetrics fm( font() );
	
	int y1 = cy / fm.height() - 1;
	int y2 = y1 + ch / fm.height() + 2;
	
	if ( y1 < 0 )
		y1 = 0;
	if ( y2 >= 65536 * 2 / 16 )
		y2 = ( 65536 * 2 / 16 ) - 1;
	
	for ( int y = y1; y <= y2; y++ )
	{
		QString s = QString( "%1: " ).arg( y * 16, 5, 16 );
		for ( int x = 0; x < 16; x++ )
			s += QString( "%1 " ).arg( buffer[ y * 16 + x ], 2, 16 );
		
		p->drawText( 0, ( y + 1 ) * fm.height(), s );
	}
}

