
;.equ	trg_dat	=	0x300	; sram address of trigger data

;.equ	trg_cfg	=	0x000	; eeprom configuration data

.equ	trg_num_max	=	8

.equ	trg_flg	=	0	; actual trigger flag
.equ	trg_flg_cur	=	1	; trigger current flag
.equ	trg_flg_can	=	3	; send    if triggered
.equ	trg_flg_pro	=	4	; process if triggered
.equ	trg_flg_lpt	=	5	; print   if triggered ( evaluated by can printer station )
.equ	trg_flg_art	=	7	; allow remote triggering


.include "trigger.inc"

.cseg


; *
; *  load initial trigger values

trg_load:
	setz	trg_cfg
	sety	trg_dat
	ldi	dh,	trg_num_max
trg_load_cpy:
	rcall	ee_read
	st	Y+,	dl
	dec	dh
	brne	trg_load_cpy
	
	ret


; *
; *  get trigger state ( T-flag )

trg_get:
	push	dl
	rcall	trg_ld
	bst	dl,	trg_flg
	pop	dl
	ret


; *
; *  toggle trigger value

trg_tgl:
	rcall	trg_ld
	
	com	dl
	bst	dl,	trg_flg
	
	;rjmp	trg_set


; *
; *  update trigger ( T-flag is new trigger value )

trg_set:
	
	brtc	trg_set_0
trg_set_1:
	rcall	trg_ld
	sbrc	dl,	trg_flg_cur
	ret
	sbr	dl,	( 1 << trg_flg ) 
	rcall	trg_sd
	sbrc	dl,	trg_flg_can
	rcall	trg_can_snd
	sbr	dl,	( 1 << trg_flg_cur )
	rcall	trg_sd
	sbrc	dl,	trg_flg_pro
	rjmp	trg_pro
	ret

trg_set_0:	
	rcall	trg_ld
	sbrs	dl,	trg_flg_cur
	ret
	cbr	dl,	( 1 << trg_flg )
	rcall	trg_sd
	sbrc	dl,	trg_flg_can
	rcall	trg_can_snd
	cbr	dl,	( 1 << trg_flg_cur )
	rcall	trg_sd
	sbrc	dl,	trg_flg_pro
	rjmp	trg_pro
	ret
	

; *
; *  reset trigger state

trg_rst:
	rcall	trg_ld
	sbrs	dl,	trg_flg
	ret
	
	cbr	dl,	( 1 << trg_flg )
	rcall	trg_sd
	sbrc	dl,	trg_flg_can
	rcall	trg_can_snd
	sbrc	dl,	trg_flg_pro
	rjmp	trg_pro


; *
; *  load trigger value

trg_ld:
	pushy
	
	andi	dh,	(trg_num_max-1)
	sety	trg_dat
	add	YL,	dh
	brcc	trg_ld_noc
	inc	YH
trg_ld_noc:
	ld	dl,	Y
	
	popy
	ret


; *
; *  store trigger value

trg_sd:
	pushy
	
	andi	dh,	(trg_num_max-1)
	sety	trg_dat
	add	YL,	dh
	brcc	trg_sd_noc
	inc	YH
trg_sd_noc:
	st	Y,	dl
	
	popy
	ret


; *
; *  send can trigger command

trg_can_snd:
	push	dl
	push	dh
	pushy
	pushz

	sety	can_dat
	
	rcall	trg_ld
	std	Y+3,	dl
	
	ldi	dl,	can_addr
	st	Y,	dl
	ldi	dl,	can_addr_ext
	std	Y+1,	dl
	ldi	dl,	cmd_tr0
	add	dl,	dh
	std	Y+2,	dl
	ldi	dl,	8
	std	Y+4,	dl
	
	swap	dh
	lsr	dh
	setz	( trg_names * 2 )
	add	ZL,	dh
	brcc	trg_can_snd_noc
	inc	ZH
trg_can_snd_noc:

	adiw	YL,	5
	
	ldi	dh,	8
trg_can_snd_cpy_name:
	lpm	dl,	Z+
	st	Y+,	dl
	dec	dh
	brne	trg_can_snd_cpy_name
	
	sety	can_dat
	rcall	can_snd_y
	
	popz
	popy
	pop	dh
	pop	dl
	ret


; *
; *  execute trigger event handler

trg_pro:
	push	dl
	push	dh
	pushz
	
	andi	dh,	0b00000111
	
	setz	trg_jmp_tab
	
	add	ZL,	dh
	brcc	trg_pro_noc
	inc	ZH
trg_pro_noc:
	
	icall
	
	popz
	pop	dh
	pop	dl
	ret


